<?php

//  Costruisce un array associativo con i dati estratti da una select
function db_array ($db, $table="", $key_field="", $val_field="", $sort_field="", $where="")
{
	
	$table = addslashes($table);
	$key_field = addslashes($key_field);
	$val_field = $val_field;
	$sort_field = addslashes($sort_field);
	
    $values = array();
  
    if (empty($table) || empty($key_field)) { return $values; }
  
    if (empty($val_field)) { $val_field = $key_field; }
    if (empty($where)) { $where = "1=1"; }
	if (empty($sort_field)) { $sort_field = "1"; }
  
    $sql = "select $key_field
            , $val_field
            from $table
            where $where
            order by $sort_field
    ";
	
    $result = $db->query($sql)
  	or die("ack! query failed: "
    ."<li>errorno=".$db->errorCode()
    ."<li>error=".$db->errorInfo()
    ."<li>query=".$sql);
    if ($result)  {
            while ($row = $result->fetch(PDO::FETCH_ASSOC))
            {
                    $values[$row[$key_field]] = $row[$val_field];
            }
			
    }
    return $values;
	
}


/*
 *   Array to Form
 */
// costruisce un controllo select con i dati contenuti in un array
function array_select_field($values, $name, $match="", $blank=false)
{
   $output = "<select name=\"$name\" id=\"$name\">";
   $selected = ($match === "") ? "selected" : "";
   if ($blank) $output .= "<option value=\"\" $selected> </option>";
   
 for ($n = 0; $n <count($values); $n++) {
    $line = each ($values);
    $val = $line[0];
    $label = $line[1];
	 
   if  (($val == $match  || $label == $match) && $match !== "" )
      { 
      $selected = "selected";
      }
    else 
      $selected = "";
    $output .= "<option value='$val' $selected> $label </option>";
  }

  $output .= "</select>";
  return "$output";
}

// costruisce l'insieme di options per un controllo select con i dati contenuti in un array
function array_select_opt($values, $match="", $blank=false)
{
   $output = "";
   $selected = ($match === "") ? "selected" : "";
   if ($blank) $output .= "<option value=\"\" $selected> </option>";
 

 for ($n = 0; $n <count($values); $n++) {
    $line = each ($values);
    $val = $line[0];
    $label = $line[1];
	
	if (is_array($match)) {
		//print "array";
		if (in_array($val,$match) || in_array($label,$match)) {
			$selected = "selected";
		} else {
			$selected = "";
		}
	} else if  (($val == $match  || $label == $match) && $match !== "" ) { 
		$selected = "selected";
    } else {
		$selected = "";
	}
    $output .= "<option value='$val' $selected> $label </option>";
  }

  return "$output";
}

// costruisce un controllo radio con i dati contenuti in un array
function array_radio_field($values, $name, $match="")
{
   $output = "";

 for ($n = 0; $n <count($values); $n++) {
    $line = each ($values);
    $val = $line[0];
    $label = $line[1];

   if  (($val == $match  || $label == $match) && $match !== "" )
      { 
      $selected = "checked";
      }
    else 
      $selected = "";
    $output .= "<input type='radio' name='$name' value='$val' $selected> $label <br>";
  }

  $output .= "";
  return "$output";
}

// costruisce un controllo checkbox con i dati contenuti nel dataset
// row[0] = id
// row[1] = label
// row[2] = checked
function array_checkbox_field($dataset, $prefname)
{
 $output = "";
 
 while($row = mysql_fetch_array( $dataset )) {
    $id = $row[0];
    $label = $row[1];
	$checked = $row[2];
	
	$mark = ($checked == "" || $checked == 0) ? "" : "checked=\"checked\"";
    $output .= " <input name=\"$prefname-$id\" type=\"checkbox\" value=\"$id\" $mark/> $label<br>";
  }

  return "$output";
}

// costruisce un controllo checkbox con i dati contenuti nel dataset raggruppando per titolo
// row[0] = id
// row[1] = label
// row[2] = checked
// row[3] = groupname
function array_checkbox_field_gr($dataset, $prefname)
{
 $output = '';
 $oldtitle = '';
 $paropen = false;
 
 while($row = mysql_fetch_array( $dataset )) {
    $id = $row[0];
    $label = $row[1];
	$checked = $row[2];
	$title = $row[3];
	$did = $row[4];
	
	if ($oldtitle != $title) {
		if ($paropen) {$output.='</p>';$paropen=false;}
		$output .= '<p class="datalist">'; 
		$paropen= true;
		$oldtitle = $title; 
		$output .= "<b>$title</b> <img src=\"../acms_images/bt_check.png\" onclick=\"checkall($did)\"> <img src=\"../acms_images/bt_uncheck.png\" onclick=\"checknone($did)\"><br>";
	}
	$mark = ($checked == "" || $checked == 0) ? "" : "checked=\"checked\"";
    $output .= " <input name=\"$prefname-$id\" type=\"checkbox\" value=\"ch-$did\" $mark/> $label<br>";
  }
  if ($paropen) {$output.='</p>';$paropen=false;}
  return $output;
}





function suddivisione_pagine($totr,$linkbase,$current,$rpp=0) {

    if ($rpp == 0) $rpp = 30;
    $numlink = 10;
  	$np = ceil($totr/$rpp);
  	$page_nav = " <b>pag $current</b> ";
  	
  	// link pagina precedente
  	if ($current > 1) {
  	  $lntmp = str_replace('#n#', $current-1, $linkbase);
  	  $page_nav .= ' '.str_replace('#t#', ' &lt;&lt;prec ', $lntmp);
  	}
  	// link pagina successiva
  	if ($current < $np) {
  	  $lntmp = str_replace('#n#', $current+1, $linkbase);
  	  $page_nav .= ' '.str_replace('#t#', " succ&gt;&gt; ", $lntmp);
  	}
  	 
    if ($np >= 2)  {
    	$page_nav .= 'vai a ';
  
    	$start = $current - ($numlink / 2);
    	if ($start <= 0) $start=1;
  
    	$end = $start + $numlink;
    	if ($end > $np) $end=$np;
  
  	  for ($i = $start; $i <= $end; $i++ )
        if ($i != $current) {
          $lntmp = str_replace('#n#', $i, $linkbase);
          $page_nav .= str_replace('#t#', $i, $lntmp);
          if ($i < $end) $page_nav .= ' | ';
        }
    }
  
    return(array($page_nav, $totr, $np));
}
  
  
function encode_url($str) {

    $str = urlencode($str);
    //$str = strtolower($str);
    //$str = mb_strtolower($str, 'UTF-8');
    $str = str_replace(' ', '-', $str);
    $str = str_replace('+', '-', $str);
    
    $str = stripslashes($str);

    return $str;
}

function decode_url($str) {
    $str = str_replace('-', ' ', $str);
    $str = urldecode($str);
    //$str = strtolower($str);
    //$str = mb_strtolower($str, 'UTF-8');
    
    $str = addslashes($str);
  
    return $str;
}

?>
